; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

    ; ----------------------------------
    ; array member count for timed tests
    ; ----------------------------------
      memsize equ <10000000>

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD 

      quicksort PROTO :DWORD,:DWORD,:DWORD
      qisort    PROTO :DWORD,:DWORD,:DWORD
      split     PROTO :DWORD,:DWORD,:DWORD
      isort     PROTO :DWORD,:DWORD,:DWORD

    ; -----------------------------
    ; macros for displaying results
    ; -----------------------------
      SBtext MACRO part,lpString
        invoke SendMessage,hStatus,SB_SETTEXT,part-1,reparg(lpString)
      ENDM

      TBtext MACRO lpString
        invoke SetWindowText,FUNC(GetActiveWindow),reparg(lpString)
      ENDM

      EDtext MACRO lpString
        invoke SetWindowText,hEdit,reparg(lpString)
      ENDM

      EDclear equ <EDtext 0>

    .data?
        hWnd      dd ?
        hInstance dd ?
        hStatus   dd ?
        hEdit     dd ?

    .code

; 

start: 
    mov hInstance, FUNC(GetModuleHandle,NULL)
    call main
    invoke ExitProcess,eax

; 

main proc

    invoke InitCommonControls

    Dialog "   ", \                         ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            9, \                            ; number of controls
            50,50,250,106, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Test qisort",WS_TABSTOP,5, 5,50,13,101
    DlgButton "Time qisort",WS_TABSTOP,5,20,50,13,102
    DlgButton "Time quicksort",WS_TABSTOP,5,35,50,13,103
    DlgButton "Unused",WS_TABSTOP,5,50,50,13,104
    DlgButton "Unused",WS_TABSTOP,5,65,50,13,105
    DlgButton "Reset",WS_TABSTOP,60,65,50,13,106
    DlgButton "Close",WS_TABSTOP,192,65,50,13,IDCANCEL
    DlgStatus 110
    DlgEdit WS_TABSTOP or ES_MULTILINE or ES_WANTRETURN or \
            ES_LEFT or WS_BORDER or WS_VSCROLL,60,5,182,58,111

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

align 4

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL hDC   :DWORD
    LOCAL pstr  :DWORD
    LOCAL hMem  :DWORD
    LOCAL ps    :PAINTSTRUCT 
    LOCAL rct   :RECT 
    LOCAL crct  :RECT 
    LOCAL buffer1[260]:BYTE 
    LOCAL buffer2[260]:BYTE 
    LOCAL buffer3[260]:BYTE 
    LOCAL buffer4[260]:BYTE 

    STRING MainTitle,"Algorith Test Bed"

    Switch uMsg
      Case WM_INITDIALOG
        m2m hWnd, hWin
        invoke SendMessage,hWnd,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        invoke SetWindowText,hWnd,ADDR MainTitle

        mov hStatus, FUNC(GetDlgItem,hWnd,110)
        GLOBAL sbarray dd 100,200,300,400,-1
        invoke SendMessage,hStatus,SB_SETPARTS,5,ADDR sbarray

        mov hEdit,   FUNC(GetDlgItem,hWnd,111)
        invoke SendMessage,hEdit,WM_SETFONT,
                           FUNC(GetStockObject,ANSI_FIXED_FONT),TRUE
        mov eax, 1

      Case WM_COMMAND
        Switch wParam
          Case 101
          ; ******************************************************

            .data
              ;; buffr dd 17,17,16,16,15,15,14,14,13,13,12,12,11,11,10,10,9,9,8,8,7,7,6,6,5,5,4,4,3,3,2,2,1,1
              buffr dd 48,47,46,45,44,43,42,41,40,39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
              ;; buffr dd 9,8,7,6,5,4,3,2,1,0
              ;; buffr dd 20,1,19,2,18,3,17,4,16,5,15,6,14,7,13,8,12,9,11,10,12,9,13,8,14,7,15,6,16,5,17,4,18,3,19,2,20,1
              ;; buffr dd 1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1

              array dd LENGTHOF buffr dup (0)
            .code

            push esi
            push edi

            mov ecx, LENGTHOF buffr
            mov esi, OFFSET buffr
            mov edi, OFFSET array
            rep movsd

            mov esi, OFFSET array

          ; ==========================

            invoke qisort,OFFSET array,0,LENGTHOF buffr

            ;; invoke quicksort,OFFSET array,0,LENGTHOF buffr

            ;; invoke isort,OFFSET array,0,LENGTHOF buffr

          ; ==========================

            mov esi, OFFSET array
            mov pstr, ptr$(buffer1)

            mov edi, LENGTHOF array
          @@:
            mov pstr, cat$(pstr,str$([esi]))
            add esi, 4
            sub edi, 1
            jz @F
            mov pstr, cat$(pstr,".")
            jmp @B
          @@:

            EDtext pstr

            pop edi
            pop esi

          ; ******************************************************
          Case 102
            invoke nseed, 87654321

            mov hMem, alloc(memsize*4)

            push esi
            push edi

            mov esi, memsize
            mov edi, hMem
          @@:
            invoke nrandom, memsize
            mov [edi], eax
            add edi, 4
            sub esi, 1
            jnz @B

            pop edi
            pop esi

            invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS

            invoke GetTickCount
            push eax

          ; ==========================
            invoke qisort,hMem,0,memsize
          ; ==========================

            invoke GetTickCount
            pop ecx
            sub eax, ecx

            fn MessageBox,hWnd,str$(eax),"Title",MB_OK

            free hMem

            invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

          Case 103
            invoke nseed, 87654321

            mov hMem, alloc(memsize*4)

            push esi
            push edi

            mov esi, memsize
            mov edi, hMem
          @@:
            invoke nrandom, memsize
            mov [edi], eax
            add edi, 4
            sub esi, 1
            jnz @B

            pop edi
            pop esi

            invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS

            invoke GetTickCount
            push eax

          ; ==========================
            invoke quicksort,hMem,0,memsize
          ; ==========================

            invoke GetTickCount
            pop ecx
            sub eax, ecx

            fn MessageBox,hWnd,str$(eax),"Title",MB_OK

            free hMem

            invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

          Case 104
            TBtext "ID 104"
            SBtext 4,"Test 4"
            EDtext "The 4th button was pressed"

          Case 105
            TBtext "ID 105"
            SBtext 5,"Test 5"
            EDtext "OK, you pressed button 5"

          Case 106
            EDclear
            SBtext 1,0
            SBtext 2,0
            SBtext 3,0
            SBtext 4,0
            SBtext 5,0
            TBtext ADDR MainTitle

          Case IDCANCEL
            jmp quit_dialog
        Endsw

      Case WM_PAINT
        mov hDC, FUNC(BeginPaint,hWin,ADDR ps)
        invoke GetClientRect,hWin,ADDR rct
        invoke GetWindowRect,hStatus,ADDR crct
        mov eax, crct.bottom
        sub eax, crct.top
        sub rct.bottom, eax
        invoke DrawEdge,hDC,ADDR rct,EDGE_ETCHED,BF_RECT
        invoke EndPaint,hWin,ADDR ps

      Case WM_CLOSE
        quit_dialog: 
        invoke EndDialog,hWin,0
    Endsw

    xor eax, eax
    ret

DlgProc endp

; 

align 4

qisort proc arr:DWORD,i:DWORD,j:DWORD

    push edi

    mov eax, j
    sub eax, i
    cmp eax, 48                 ; minimum size for qisort
    jb islbl                    ; else insertion sort

  ; ----------------------------

    invoke split,arr,i,j
    mov edi, eax

    sub edi, 1
    invoke qisort,arr,i,edi

    add edi, 1
    invoke qisort,arr,edi,j
    jmp @F

  align 4
  islbl:
    invoke isort,arr,i,j

  ; ----------------------------
  @@:

    pop edi

    ret

qisort endp

; 

align 4

quicksort proc arr:DWORD,i:DWORD,j:DWORD

    push edi

    mov eax, j
    cmp i, eax
    jge @F
  ; ----------------------------

    invoke split,arr,i,j
    mov edi, eax

    sub edi, 1
    invoke quicksort,arr,i,edi

    add edi, 1
    invoke quicksort,arr,edi,j

  ; ----------------------------
  @@:

    pop edi

    ret

quicksort endp

; 

align 4

split proc arr:DWORD,lb:DWORD,ub:DWORD

    push ebx
    push esi
    push edi
    push ebp

    mov ebx, arr                ; array address in EBX
    sub ebx, 4
    mov edx, ub                 ; upper bound
    mov esi, ub
    mov edi, [ebx+esi*4]
    mov ebp, lb                 ; lower bound
  ; *******************************************
    cmp ebp, edx
    ja lpout
  @@:
    add ebp, 1
  ulin:
    cmp [ebx+ebp*4], edi
    jb @B
  ; -------------------------
    add edx, 1
  @@:
    sub edx, 1
    cmp ebp, edx
    ja lpout
    cmp [ebx+edx*4], edi
    jnb @B
  ; -------------------------
    mov eax, [ebx+edx*4]
    mov ecx, [ebx+ebp*4]
    mov [ebx+ebp*4], eax
    mov [ebx+edx*4], ecx
    add ebp, 1
    sub edx, 1

    cmp ebp, edx
    jbe ulin
  ; *******************************************
  lpout:
    mov eax, [ebx+esi*4]
    mov ecx, [ebx+ebp*4]
    mov [ebx+ebp*4], eax
    mov [ebx+esi*4], ecx

    mov eax, ebp

    pop ebp
    pop edi
    pop esi
    pop ebx

    ret

split endp


; 

align 4

isort proc arr:DWORD,lb:DWORD,ub:DWORD

    push ebx
    push esi
    push edi

    mov ebx, arr                ; array address in EBX
    sub ebx, 4
    mov esi, lb                 ; For i = Lb + 1 To Ub '' i = ub
    add esi, 1                  ; esi = lb + 1
    jmp jmpin

  align 4
  outer:
  ; *******************
    mov edx, [ebx+esi*4]        ; t = arr(i)
    mov edi, esi                ; For j = i - 1 To Lb Step - 1
    sub edi, 1
    jmp intoit
  align 4
  inner:
    cmp [ebx+edi*4], edx
    jbe outofit                 ; insertion point found
    mov eax, [ebx+edi*4]
    mov [ebx+edi*4+4], eax      ; move arr(j) up 1
    sub edi, 1
  intoit:
    cmp edi, lb
    jge inner                   ; Next
  ; *******************
  outofit:
    mov [ebx+edi*4+4], edx      ; insert
    add esi, 1
  jmpin:
    cmp esi, ub    
    jbe outer                   ; Next

    pop edi
    pop esi
    pop ebx

    ret

isort endp

; 

end start


















